/**
 * Basic node stored in AVL trees
 */

public class AvlNode {

  /**
   * The data in the node
   */
  public int key;
  
  public Object el;

  /**
   * Left child
   */
  public AvlNode    left;

  /**
   * Right child
   */
  public AvlNode    right;

  /**
   * Height
   */
  public int        height;
  
  
  /**
   * Size of subtree
   */
  public int        size;


  //
  /**
   * Creates a new node without children.
   * @param theElement to insert.
   */
  AvlNode( int theKey, Object theEl ){
    this( theKey, theEl, null, null );
    }

    /**
     * Creates a new node with children and heigth equals to zero
     * @param theElement the key of the node.
     * @param lt the left child.
     * @param rt the right child.
     */
    AvlNode( int theKey, Object theEl, AvlNode lt, AvlNode rt ){
    key  = theKey;
    el = theEl;
    left     = lt;
    right    = rt;
    height   = 0;
    size     = 1;
    }
    

}